#ifndef BUILDERGRID_H
#define BUILDERGRID_H

#include "builder.h"

class BuilderGrid : public Builder
{
	public:

		virtual void build(VertexVector & vertices, TriangleVector & triangles) const
		{
			const int n = 256;

			vertices.resize((n+1)*(n+1));
			int k = 0;
			for (int y=0; y<(n+1); ++y)
			{
				for (int x=0; x<(n+1); ++x)
				{
					Vertex & v = vertices[k];

					v.position [0] = -0.5f + (float(x) / float(n-1));
					v.position [1] = -0.5f + (float(y) / float(n-1));
					v.position [2] =  0.0f;

					v.normal   [0] =  0.0f;
					v.normal   [1] =  0.0f;
					v.normal   [2] =  1.0f;

					v.texcoord [0] =  0.0f;
					v.texcoord [1] =  0.0f;

					v.color    [0] =     0;
					v.color    [1] =     0;
					v.color    [2] =   255;
					v.color    [3] =   255;

					k++;
				}
			}

			triangles.resize(n * n * 2);
			k = 0;
			for (int y=0; y<n; ++y)
			{
				for (int x=0; x<n; ++x)
				{
					Triangle & t1 = triangles[k];
					t1.vertices[0] = ((y+0)*(n+1)) + (x+0);
					t1.vertices[1] = ((y+0)*(n+1)) + (x+1);
					t1.vertices[2] = ((y+1)*(n+1)) + (x+0);
					k++;

					Triangle & t2 = triangles[k];
					t2.vertices[0] = ((y+1)*(n+1)) + (x+0);
					t2.vertices[1] = ((y+0)*(n+1)) + (x+1);
					t2.vertices[2] = ((y+1)*(n+1)) + (x+1);
					k++;
				}
			}
		}
};

#endif // BUILDERGRID_H
